<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): tiglMutationMessageImplementation.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_e1c3629206a62d7880de84e139cd6012.html">src</a></li><li class="navelem"><a class="el" href="dir_5923310312939235796ca11289acda83.html">common</a></li><li class="navelem"><a class="el" href="dir_cefb8d6b2db0343bb075f98034598653.html">mutation</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglMutationMessageImplementation.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglMutationMessageImplementation_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef TIGLMUTATIONMESSAGEIMPLEMENTATION_HPP</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define TIGLMUTATIONMESSAGEIMPLEMENTATION_HPP</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* Copyright (C) 2015 Texas Instruments Incorporated - http://www.ti.com/</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * modification, are permitted provided that the following conditions</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * are met:</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *    Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *    Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *    notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *    documentation and/or other materials provided with the</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *    distribution.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *    Neither the name of Texas Instruments Incorporated nor the names of</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *    its contributors may be used to endorse or promote products derived</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *    from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> * &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment"> * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="comment"> * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="comment"> * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"> * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="comment"> * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment"> * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="comment"> * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="comment"> * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="comment"> * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"> * INCLUDES</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="comment"> ******************************************************************************/</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#include  &lt;stdint.h&gt;</span></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#include  &lt;algorithm&gt;</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="preprocessor">#include  &lt;vector&gt;</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#include  &lt;string.h&gt;</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a7a78a4b0b8bf099b5a38afe2f5886746">   61</a></span>&#160;uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#a7a78a4b0b8bf099b5a38afe2f5886746">TIGLMutationMessage::prepareAddEdgeMessage</a>(EdgeType *pEdge, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;{</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;   messageBody.clear();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;   uint8_t *p = (uint8_t *) targetVertex;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;   messageBody.insert(messageBody.begin(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;   p = (uint8_t *) pEdge;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;   messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(EdgeType));</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;   <span class="keywordflow">return</span> messageBody.size() + 1;   <span class="comment">// one uint8_t is added for the message code</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;}</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a2f04a7b6741580d694fb492ddad9e552">   81</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a2f04a7b6741580d694fb492ddad9e552">TIGLMutationMessage::readAddEdgeMessage</a>(EdgeType *pEdge, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;{</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;   <span class="keywordflow">if</span> (messageBody.size() != <span class="keyword">sizeof</span>(EdgeType) + <span class="keyword">sizeof</span>(ID_TYPE))</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;   uint8_t *p = (uint8_t *) targetVertex;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;   std::copy(messageBody.begin(), messageBody.begin() + <span class="keyword">sizeof</span>(ID_TYPE), p);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;   p = (uint8_t *) pEdge;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;   std::copy(messageBody.begin() + <span class="keyword">sizeof</span>(ID_TYPE), messageBody.end(), p);</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;}</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EDGE_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00103"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#aa9d443dae0e56c7f05a1932937aa0295">  103</a></span>&#160;uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#aa9d443dae0e56c7f05a1932937aa0295">TIGLMutationMessage::prepareRemoveEdgeMessage</a>(<a class="code" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a> *edge, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;{</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;   messageBody.clear();</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;   uint8_t *p = (uint8_t *) targetVertex;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;   messageBody.insert(messageBody.begin(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;   ID_TYPE nbrVertex = edge-&gt;<a class="code" href="classTIGLContainersEdgeBase.html#a66709a50757848d82d194ddcdf5444be">getNbr</a>();</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;   p = (uint8_t *) &amp;nbrVertex;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;   messageBody.insert(messageBody.begin(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;   <span class="keywordflow">return</span> messageBody.size() + 1;   <span class="comment">// one uint8_t is added for the message code</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;}</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#af8c92aba9f2e483d8422cd874e7fa8f8">  124</a></span>&#160;uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#aa9d443dae0e56c7f05a1932937aa0295">TIGLMutationMessage::prepareRemoveEdgeMessage</a>(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;{</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;   messageBody.clear();</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;   uint8_t *p = (uint8_t *) targetVertex;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;   messageBody.insert(messageBody.begin(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;   p = (uint8_t *) nbrVertex;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;   messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));   <span class="comment">//std::copy(p, p+sizeof(ID_TYPE), messageBody.end());</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;   <span class="keywordflow">return</span> messageBody.size() + 1;   <span class="comment">// one uint8_t is added for the message code</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;}</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00144"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a4b5d767c6ed05892eed00407a290e599">  144</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a4b5d767c6ed05892eed00407a290e599">TIGLMutationMessage::readRemoveEdgeMessage</a>(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;{</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;   <span class="keywordflow">if</span> (messageBody.size() != 2 * <span class="keyword">sizeof</span>(ID_TYPE))</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;   uint8_t *p = (uint8_t *) &amp;targetVertex;</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;   std::copy(messageBody.begin(), messageBody.begin() + <span class="keyword">sizeof</span>(ID_TYPE), p);</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;   p = (uint8_t *) nbrVertex;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;   std::copy(messageBody.begin() + <span class="keyword">sizeof</span>(ID_TYPE), messageBody.end(), p);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;}</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#ac3e3ba4f54b0d67c6e5bc7a979c2e329">  165</a></span>&#160;uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#ac3e3ba4f54b0d67c6e5bc7a979c2e329">TIGLMutationMessage::prepareEmptyVertexMessage</a>(ID_TYPE *vertexId)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;{</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;   messageBody.clear();</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;   <span class="comment">//messageBody.reserve(sizeof(ID_TYPE));</span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;   uint8_t *p = (uint8_t *) vertexId;</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;   messageBody.insert(messageBody.begin(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;   <span class="keywordflow">return</span> messageBody.size() + 1;   <span class="comment">// one uint8_t is added for the message code</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;}</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00183"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#af3b1ee90ab9cad65a113cdd51cfd9522">  183</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#af3b1ee90ab9cad65a113cdd51cfd9522">TIGLMutationMessage::readEmptyVertexMessage</a>(ID_TYPE *vertexId)</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;{</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;   <span class="keywordflow">if</span> (messageBody.size() != <span class="keyword">sizeof</span>(ID_TYPE))</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;   uint8_t *p = (uint8_t *) vertexId;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;   std::copy(messageBody.begin(), messageBody.end(), p);</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;}</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00202"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#ae9189e2cb953e7028b7523db1be12335">  202</a></span>&#160;uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#ae9189e2cb953e7028b7523db1be12335">TIGLMutationMessage::prepareAddVertexMessage</a>(<a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> *vertex)</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;{</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE <a class="code" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a>;</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR EDGE_ITERATOR;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ALG_DATA_TYPE ALG_DATA_TYPE;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::DATA_TYPE DATA_TYPE;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;   messageBody.clear();</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;   <span class="comment">// adding the objecte information</span></div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;   ID_TYPE <span class="keywordtype">id</span> = vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">getId</a>();</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;   uint8_t *p = (uint8_t *) &amp;<span class="keywordtype">id</span>;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;   messageBody.insert(messageBody.begin(), p, p + <span class="keyword">sizeof</span>(ID_TYPE));</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;   <span class="comment">// adding vertexData information</span></div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;   DATA_TYPE vertexData = vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">get_value</a>();</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;   p = (uint8_t *) &amp;vertexData;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;   messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(DATA_TYPE));</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;   <span class="comment">// adding algData information</span></div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;   ALG_DATA_TYPE algData = vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">getAlgData</a>();</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;   p = (uint8_t *) &amp;algData;</div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;   messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(ALG_DATA_TYPE));</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;   <span class="comment">// finally adding edge information</span></div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;   <span class="comment">// adding number of output edges</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;   uint_fast32_t numEdges = vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">getNumOutEdges</a>();</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;   p = (uint8_t *) &amp;numEdges;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;   messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(uint_fast32_t));</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;   <span class="keywordflow">for</span> (EDGE_ITERATOR it = vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">getBeginOutEdgeIterator</a>(); it != vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">getEndOutEdgeIterator</a>(); ++it)</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;   {</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;      EDGE_TYPE edge = *it;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;      p = (uint8_t *) &amp;edge;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;      messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(EDGE_TYPE));</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;   }</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;   <span class="comment">// checking if it has input edge buffer</span></div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;   <span class="keywordflow">if</span> (vertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">isBiVertex</a>())</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;   {</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;      uint_fast32_t numInEdges = vertex-&gt;get_num_in_edges();</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;      p = (uint8_t *) &amp;numInEdges;</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;      messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(uint_fast32_t));</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;      <span class="keywordflow">for</span> (EDGE_ITERATOR it = vertex-&gt;getBeginInEdgeIterator(); it != vertex-&gt;getEndInEdgeIterator(); ++it)</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;      {</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;         EDGE_TYPE edge = *it;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;         p = (uint8_t *) &amp;edge;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;         messageBody.insert(messageBody.end(), p, p + <span class="keyword">sizeof</span>(EDGE_TYPE));</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;      }</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;   }</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;   <span class="keywordflow">return</span> messageBody.size() + 1;   <span class="comment">// one uint8_t is added for the message code</span></div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;}</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00264"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a9985aad84627e17146f6413e8d117766">  264</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a9985aad84627e17146f6413e8d117766">TIGLMutationMessage::readAddVertexMessage</a>(<a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> *pVertex)</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;{</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ID_TYPE ID_TYPE;</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE <a class="code" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a>;</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ALG_DATA_TYPE ALG_DATA_TYPE;</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;   <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::DATA_TYPE DATA_TYPE;</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;   <span class="comment">//uint_fast32_t index;</span></div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;   <span class="comment">// adding the objecte information</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;   ID_TYPE id;</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;   uint8_t *p = (uint8_t *) &amp;<span class="keywordtype">id</span>;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;   BYTE_ITERATOR it = messageBody.begin();</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;   BYTE_ITERATOR itBound = it + <span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;   <span class="keywordflow">if</span> (itBound == messageBody.end())</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;   {</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;   }</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;   std::copy(it, itBound, p);</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;   <span class="comment">// adding vertexData information</span></div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;   DATA_TYPE vertexData;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;   p = (uint8_t *) &amp;vertexData;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;   it = itBound;</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;   itBound += <span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;   <span class="keywordflow">if</span> (itBound == messageBody.end())</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;   {</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;   }</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;   std::copy(it, itBound, p);</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;   <span class="comment">// adding algData information</span></div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;   ALG_DATA_TYPE algData;</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;   p = (uint8_t *) &amp;algData;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;   it = itBound;</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;   itBound += <span class="keyword">sizeof</span>(ALG_DATA_TYPE);</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;   <span class="keywordflow">if</span> (itBound == messageBody.end())</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;   {</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;   }</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;   std::copy(it, itBound, p);</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;   pVertex-&gt;setParams(<span class="keywordtype">id</span>, vertexData, algData);</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;   <span class="comment">// finally adding edge information</span></div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;   <span class="comment">// adding number of output edges</span></div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;   uint_fast32_t numEdges;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;   p = (uint8_t *) &amp;numEdges;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;   it = itBound;</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;   itBound += <span class="keyword">sizeof</span>(uint_fast32_t);</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;   std::copy(it, itBound, p);</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;   <span class="keywordflow">if</span> (itBound == messageBody.end())</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;   {</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;      <span class="keywordflow">if</span> (numEdges)</div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;         <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;   }</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;   <span class="keywordflow">for</span> (uint_fast32_t i = 0; i &lt; numEdges; i++)</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;   {</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;      EDGE_TYPE edge(0);</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;      p = (uint8_t *) &amp;edge;</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;      it = itBound;</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;      itBound += <span class="keyword">sizeof</span>(EDGE_TYPE);</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;      <span class="keywordflow">if</span> (itBound == messageBody.end() &amp;&amp; i &lt; numEdges - 1)</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;      {</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;         <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;      }</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;      std::copy(it, itBound, p);</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;      pVertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">addEdge</a>(edge);</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;   }</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;   <span class="comment">// checking if it has input edge buffer</span></div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;   <span class="keywordflow">if</span> (pVertex-&gt;<a class="code" href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">isBiVertex</a>())</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;   {</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;      uint_fast32_t numInEdges;</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;      it = itBound;</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;      itBound += <span class="keyword">sizeof</span>(uint_fast32_t);</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;      std::copy(it, itBound, p);</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;      <span class="keywordflow">if</span> (itBound == messageBody.end())</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;      {</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;         <span class="keywordflow">if</span> (numInEdges)</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;      }</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;      <span class="keywordflow">for</span> (uint_fast32_t i = 0; i &lt; numInEdges; i++)</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;      {</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;         EDGE_TYPE edge(0);</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;         p = (uint8_t *) &amp;edge;</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;         it = itBound;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;         itBound += <span class="keyword">sizeof</span>(EDGE_TYPE);</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;         <span class="keywordflow">if</span> (itBound == messageBody.end() &amp;&amp; i &lt; numEdges - 1)</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;         {</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;         }</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;         std::copy(it, itBound, p);</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;         pVertex-&gt;addInEdge(edge);</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;      }</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;   }</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;}</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00370"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#accca8b14abee53083d4b770e4f953922">  370</a></span>&#160;<span class="keyword">inline</span> MUTATION_MESSAGE_CODE <a class="code" href="classTIGLMutationMessage.html#accca8b14abee53083d4b770e4f953922">TIGLMutationMessage::getMessageCode</a>()</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;{</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;   <span class="keywordflow">return</span> messageCode;</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;}</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00381"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a3d17a5a5e1dfe646b1dc7e8761a351b7">  381</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#a3d17a5a5e1dfe646b1dc7e8761a351b7">TIGLMutationMessage::getSizeInBytes</a>()</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;{</div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;   <span class="keywordflow">return</span> messageBody.size() + <span class="keyword">sizeof</span>(uint_fast32_t) + 1;</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;}</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00392"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a3f973031daac84719897d93512d351ab">  392</a></span>&#160;<span class="keyword">inline</span> int_fast32_t <a class="code" href="classTIGLMutationMessage.html#a3f973031daac84719897d93512d351ab">TIGLMutationMessage::getDstDev</a>()</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;{</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;   <span class="keywordflow">return</span> otherDevice;</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;}</div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00404"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a6fb578a6baf57eeddee242c28c334536">  404</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a6fb578a6baf57eeddee242c28c334536">TIGLMutationMessage::getDstVertex</a>(ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;{</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;   <span class="keywordflow">if</span> (messageCode == ADD_VERTEX)</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;   {</div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;      <span class="comment">//tobe defined</span></div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;   }</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;   <span class="comment">// all other cases the target vertex is set at the beginning of the message</span></div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;   uint8_t *p = (uint8_t *) targetVertex;</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;   std::copy(messageBody.begin(), messageBody.begin() + <span class="keyword">sizeof</span>(ID_TYPE), p);</div>
<div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;}</div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00427"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a1d1bbd783f0209096d743278a88555cf">  427</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#a1d1bbd783f0209096d743278a88555cf">TIGLMutationMessage::pack</a>(uint8_t *buf)</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;{</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;   <span class="comment">// putting the message code</span></div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;   uint8_t firstByte = (uint8_t) messageCode;   <span class="comment">//</span></div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;   *(buf++) = firstByte;</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;   uint_fast32_t bodySize = messageBody.size();</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;   memcpy(buf, &amp;bodySize, <span class="keyword">sizeof</span>(uint_fast32_t));   <span class="comment">// including the size of message body in the message header</span></div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;   buf += <span class="keyword">sizeof</span>(uint_fast32_t);</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;   <span class="keywordflow">if</span> (bodySize)</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;      std::copy(messageBody.begin(), messageBody.end(), buf);</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;   <span class="keywordflow">return</span> bodySize + <span class="keyword">sizeof</span>(uint_fast32_t) + 1;   <span class="comment">// including the size (4 bytes) and the message code (1 uint8_t)</span></div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;}</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00450"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a9f939c9fab8f95de9e5a7ce5e4e21764">  450</a></span>&#160;<span class="keyword">inline</span> uint_fast32_t <a class="code" href="classTIGLMutationMessage.html#a9f939c9fab8f95de9e5a7ce5e4e21764">TIGLMutationMessage::unpack</a>(uint8_t *buf)</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;{</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;   messageCode = (MUTATION_MESSAGE_CODE) (*(buf++));</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;   uint_fast32_t bodySize;</div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;   memcpy(&amp;bodySize, buf, <span class="keyword">sizeof</span>(uint_fast32_t));</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;   buf += <span class="keyword">sizeof</span>(uint_fast32_t);</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;   messageBody.clear();</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;   <span class="keywordflow">if</span> (bodySize)</div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;      messageBody.insert(messageBody.begin(), buf, buf + bodySize);</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;</div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;   <span class="keywordflow">return</span> bodySize + 1 + <span class="keyword">sizeof</span>(uint_fast32_t);</div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;}</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00472"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#afaadae81d282d01fa6890bb5ec7c51ad">  472</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#afaadae81d282d01fa6890bb5ec7c51ad">TIGLMutationMessage::readVertexMessage</a>(<a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> *vertex)</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;{</div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;   <span class="keywordflow">switch</span> (messageCode) {</div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;      <span class="keywordflow">case</span> ADD_VERTEX:</div>
<div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;         <span class="keywordflow">return</span> readAddVertexMessage(vertex);</div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;         <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;<span class="comment">//    case MIGRATE_VERTEX:</span></div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;<span class="comment">//       return readMigrateVertexMessage(vertex);</span></div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;<span class="comment">//       break;</span></div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;      <span class="keywordflow">default</span>:</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;         cout &lt;&lt; <span class="stringliteral">&quot;!!!!!!!! ERROR in TIGLMutationMessage::readVertexMessage wrong call&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;   }</div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;}</div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00495"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a7dcf60d501682468cf9eaf3ff3991713">  495</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a7dcf60d501682468cf9eaf3ff3991713">TIGLMutationMessage::readSimpleVertexMessage</a>(ID_TYPE *<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;{</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;   <span class="keywordflow">if</span> (messageCode == ADD_EMPTY_VERTEX || messageCode == REMOVE_VERTEX)</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;      <span class="keywordflow">return</span> readEmptyVertexMessage(<span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;}</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;</div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EDGE_TYPE, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00512"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#aa74f399c9cebff04a96b3404a51c5e1b">  512</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#aa74f399c9cebff04a96b3404a51c5e1b">TIGLMutationMessage::readEdgeMessage</a>(<a class="code" href="classTIGLContainersEdgeBase.html">EDGE_TYPE</a> *edge, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;{</div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;   <span class="keywordflow">if</span> (messageCode == ADD_OUT_EDGE || messageCode == ADD_IN_EDGE)</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;      <span class="keywordflow">return</span> readAddEdgeMessage(edge, targetVertex);</div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;   cout &lt;&lt; <span class="stringliteral">&quot;!!!!!!!! ERROR in TIGLMutationMessage::readEdgeMessage: wrong call&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;}</div>
<div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;</div>
<div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00530"></a><span class="lineno">  530</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00531"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a7f613f63ba43876ccfb71c8345062cfc">  531</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a7f613f63ba43876ccfb71c8345062cfc">TIGLMutationMessage::readSimpleEdgeMessage</a>(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;{</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;   <span class="keywordflow">if</span> (messageCode != REMOVE_OUT_EDGE &amp;&amp; messageCode != REMOVE_IN_EDGE)</div>
<div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;   <span class="keywordflow">return</span> readRemoveEdgeMessage(nbrVertex, targetVertex);</div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;}</div>
<div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;</div>
<div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00548"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#ab9271622ced744b984d48b1d7279aa9c">  548</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#ab9271622ced744b984d48b1d7279aa9c">TIGLMutationMessage::writeEdgeMessage</a>(MUTATION_MESSAGE_CODE code, EdgeType *edge, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;{</div>
<div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;   messageCode = code;</div>
<div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;   <span class="keywordflow">if</span> (code != ADD_OUT_EDGE &amp;&amp; code != ADD_IN_EDGE)</div>
<div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;   {</div>
<div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;!!!!!! ERROR TIGLMutationMessage::writeEdgeMessage  wrong call&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;   }</div>
<div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;   prepareAddEdgeMessage(edge, targetVertex);</div>
<div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;}</div>
<div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;</div>
<div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00570"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">  570</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">TIGLMutationMessage::writeSimpleEdgeMessage</a>(MUTATION_MESSAGE_CODE code, ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div>
<div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;{</div>
<div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;   messageCode = code;</div>
<div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;   <span class="keywordflow">if</span> (code != REMOVE_OUT_EDGE &amp;&amp; code != REMOVE_IN_EDGE)</div>
<div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;   {</div>
<div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;!!!!!! ERROR TIGLMutationMessage::setSimpleEdgeMessage  wrong call&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;   }</div>
<div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;   prepareRemoveEdgeMessage(nbrVertex, targetVertex);</div>
<div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;}</div>
<div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;</div>
<div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00591"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#af860e1dbf7c39e451d6eaf39d2c34713">  591</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#af860e1dbf7c39e451d6eaf39d2c34713">TIGLMutationMessage::writeVertexMessage</a>(MUTATION_MESSAGE_CODE code, <a class="code" href="classTIGLContainersVertexBase.html">CVertex</a> *vertex)</div>
<div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;{</div>
<div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;   messageCode = code;</div>
<div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;</div>
<div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160;   <span class="keywordflow">if</span> (code != ADD_VERTEX <span class="comment">/*&amp;&amp; code != MIGRATE_VERTEX*/</span>)</div>
<div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;   {</div>
<div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;!!!!!! ERROR TIGLMutationMessage::writeVertexMessage  wrong call&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00598"></a><span class="lineno">  598</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;   }</div>
<div class="line"><a name="l00600"></a><span class="lineno">  600</span>&#160;</div>
<div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;   <span class="comment">//if(code == ADD_VERTEX)</span></div>
<div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;   prepareAddVertexMessage(vertex);</div>
<div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;<span class="comment">//    else // code == MIGRATE_VERTEX</span></div>
<div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;<span class="comment">//       prepareMigrateVertexMessage(vertex);</span></div>
<div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160;}</div>
<div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;</div>
<div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;<span class="comment">/*****************************************************************************/</span></div>
<div class="line"><a name="l00616"></a><span class="lineno">  616</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00617"></a><span class="lineno"><a class="line" href="classTIGLMutationMessage.html#a59efe7d8e43b57679710b703462e809d">  617</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classTIGLMutationMessage.html#a59efe7d8e43b57679710b703462e809d">TIGLMutationMessage::writeSimpleVertexMessage</a>(MUTATION_MESSAGE_CODE code, ID_TYPE *<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00618"></a><span class="lineno">  618</span>&#160;{</div>
<div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;   messageCode = code;</div>
<div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;   <span class="keywordflow">if</span> (code != ADD_EMPTY_VERTEX &amp;&amp; code != REMOVE_VERTEX)</div>
<div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;   {</div>
<div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;      cout &lt;&lt; <span class="stringliteral">&quot;!!!!!! ERROR TIGLMutationMessage::writeSimpleVertexMessage  wrong call&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;      <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160;   }</div>
<div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;   prepareEmptyVertexMessage(<span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;   <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;}</div>
<div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a077ed089a01250a2d15fc5acc7e3aaf6"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a077ed089a01250a2d15fc5acc7e3aaf6">TIGLContainersVertexBase::getBeginOutEdgeIterator</a></div><div class="ttdeci">OUT_EDGE_ITERATOR getBeginOutEdgeIterator()</div><div class="ttdoc">Returns an iterator to the start of the outEdges buffer. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:345</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_af3b1ee90ab9cad65a113cdd51cfd9522"><div class="ttname"><a href="classTIGLMutationMessage.html#af3b1ee90ab9cad65a113cdd51cfd9522">TIGLMutationMessage::readEmptyVertexMessage</a></div><div class="ttdeci">bool readEmptyVertexMessage(ID_TYPE *vertexId)</div><div class="ttdoc">Reads the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:183</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a7f613f63ba43876ccfb71c8345062cfc"><div class="ttname"><a href="classTIGLMutationMessage.html#a7f613f63ba43876ccfb71c8345062cfc">TIGLMutationMessage::readSimpleEdgeMessage</a></div><div class="ttdeci">bool readSimpleEdgeMessage(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div><div class="ttdoc">Procedure for reading remove edge messages. It has two outupts. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:531</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a3af614e7143fb092f6a3115514de319b"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a3af614e7143fb092f6a3115514de319b">TIGLContainersVertexBase::getEndOutEdgeIterator</a></div><div class="ttdeci">OUT_EDGE_ITERATOR getEndOutEdgeIterator()</div><div class="ttdoc">Returns an iterator to the last edge of the outEdges buffer. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:356</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_af860e1dbf7c39e451d6eaf39d2c34713"><div class="ttname"><a href="classTIGLMutationMessage.html#af860e1dbf7c39e451d6eaf39d2c34713">TIGLMutationMessage::writeVertexMessage</a></div><div class="ttdeci">bool writeVertexMessage(MUTATION_MESSAGE_CODE code, CVertex *vertex)</div><div class="ttdoc">Procedure for writing ADD/MIGRATE vertex messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:591</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a776920aff39617337c8c0d11100fa948"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a776920aff39617337c8c0d11100fa948">TIGLContainersVertexBase::get_value</a></div><div class="ttdeci">DataType &amp; get_value()</div><div class="ttdoc">Returns the vertex data field. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:312</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a6fb578a6baf57eeddee242c28c334536"><div class="ttname"><a href="classTIGLMutationMessage.html#a6fb578a6baf57eeddee242c28c334536">TIGLMutationMessage::getDstVertex</a></div><div class="ttdeci">bool getDstVertex(ID_TYPE *targetVertex)</div><div class="ttdoc">returns destination vertex </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:404</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a7a78a4b0b8bf099b5a38afe2f5886746"><div class="ttname"><a href="classTIGLMutationMessage.html#a7a78a4b0b8bf099b5a38afe2f5886746">TIGLMutationMessage::prepareAddEdgeMessage</a></div><div class="ttdeci">uint_fast32_t prepareAddEdgeMessage(EdgeType *pEdge, ID_TYPE *targetVertex)</div><div class="ttdoc">Prepares the ADD_OUT/IN_EDGE mutation message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:61</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_ac3e3ba4f54b0d67c6e5bc7a979c2e329"><div class="ttname"><a href="classTIGLMutationMessage.html#ac3e3ba4f54b0d67c6e5bc7a979c2e329">TIGLMutationMessage::prepareEmptyVertexMessage</a></div><div class="ttdeci">uint_fast32_t prepareEmptyVertexMessage(ID_TYPE *vertexId)</div><div class="ttdoc">Prepares the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:165</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_ae9189e2cb953e7028b7523db1be12335"><div class="ttname"><a href="classTIGLMutationMessage.html#ae9189e2cb953e7028b7523db1be12335">TIGLMutationMessage::prepareAddVertexMessage</a></div><div class="ttdeci">uint_fast32_t prepareAddVertexMessage(CVertex *vertex)</div><div class="ttdoc">Prepares the ADD_VERTEX message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:202</div></div>
<div class="ttc" id="classTIGLContainersEdgeBase_html"><div class="ttname"><a href="classTIGLContainersEdgeBase.html">TIGLContainersEdgeBase</a></div><div class="ttdoc">Core edge class. </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:66</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_aa74f399c9cebff04a96b3404a51c5e1b"><div class="ttname"><a href="classTIGLMutationMessage.html#aa74f399c9cebff04a96b3404a51c5e1b">TIGLMutationMessage::readEdgeMessage</a></div><div class="ttdeci">bool readEdgeMessage(EDGE_TYPE *edge, ID_TYPE *targetVertex)</div><div class="ttdoc">Procedure for reading add edge messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:512</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_accca8b14abee53083d4b770e4f953922"><div class="ttname"><a href="classTIGLMutationMessage.html#accca8b14abee53083d4b770e4f953922">TIGLMutationMessage::getMessageCode</a></div><div class="ttdeci">MUTATION_MESSAGE_CODE getMessageCode()</div><div class="ttdoc">returns the mutation message code </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:370</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a2f04a7b6741580d694fb492ddad9e552"><div class="ttname"><a href="classTIGLMutationMessage.html#a2f04a7b6741580d694fb492ddad9e552">TIGLMutationMessage::readAddEdgeMessage</a></div><div class="ttdeci">bool readAddEdgeMessage(EdgeType *pEdge, ID_TYPE *targetVertex)</div><div class="ttdoc">Reads the ADD/REMOVE_EDGE mutation message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:81</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a1d1bbd783f0209096d743278a88555cf"><div class="ttname"><a href="classTIGLMutationMessage.html#a1d1bbd783f0209096d743278a88555cf">TIGLMutationMessage::pack</a></div><div class="ttdeci">uint_fast32_t pack(uint8_t *buf)</div><div class="ttdoc">Packs the mutation message into bytes the packed message contains the message code and the message bo...</div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:427</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_af0521f19891d34cc1dfba07ec5bd83cd"><div class="ttname"><a href="classTIGLContainersVertexBase.html#af0521f19891d34cc1dfba07ec5bd83cd">TIGLContainersVertexBase::isBiVertex</a></div><div class="ttdeci">bool isBiVertex()</div><div class="ttdoc">Checks if the vertex type is TIGLContainersBiVertex. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:383</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a3f973031daac84719897d93512d351ab"><div class="ttname"><a href="classTIGLMutationMessage.html#a3f973031daac84719897d93512d351ab">TIGLMutationMessage::getDstDev</a></div><div class="ttdeci">int_fast32_t getDstDev()</div><div class="ttdoc">reading teh destination device </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:392</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a7cc87d2b4157b298460486dab71dfb44"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a7cc87d2b4157b298460486dab71dfb44">TIGLContainersVertexBase::addEdge</a></div><div class="ttdeci">void addEdge(EdgeType &amp;x)</div><div class="ttdoc">Adds output edge. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:199</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a7dcf60d501682468cf9eaf3ff3991713"><div class="ttname"><a href="classTIGLMutationMessage.html#a7dcf60d501682468cf9eaf3ff3991713">TIGLMutationMessage::readSimpleVertexMessage</a></div><div class="ttdeci">bool readSimpleVertexMessage(ID_TYPE *id)</div><div class="ttdoc">Procedure for reading add/migrate vertex messages. It. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:495</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_ab9271622ced744b984d48b1d7279aa9c"><div class="ttname"><a href="classTIGLMutationMessage.html#ab9271622ced744b984d48b1d7279aa9c">TIGLMutationMessage::writeEdgeMessage</a></div><div class="ttdeci">bool writeEdgeMessage(MUTATION_MESSAGE_CODE code, EdgeType *edge, ID_TYPE *targetVertex)</div><div class="ttdoc">Procedure for writing ADD edge messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:548</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a8aa2da8ab2f06ff33fb499ee42b228ce"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a8aa2da8ab2f06ff33fb499ee42b228ce">TIGLContainersVertexBase::getNumOutEdges</a></div><div class="ttdeci">uint_fast32_t getNumOutEdges()</div><div class="ttdoc">Returns the total number of output edges. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:261</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a59efe7d8e43b57679710b703462e809d"><div class="ttname"><a href="classTIGLMutationMessage.html#a59efe7d8e43b57679710b703462e809d">TIGLMutationMessage::writeSimpleVertexMessage</a></div><div class="ttdeci">bool writeSimpleVertexMessage(MUTATION_MESSAGE_CODE code, ID_TYPE *id)</div><div class="ttdoc">Procedure for writing add empty/remove vertex messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:617</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a183239c71e1e921ce501e10376baa0d5"><div class="ttname"><a href="classTIGLMutationMessage.html#a183239c71e1e921ce501e10376baa0d5">TIGLMutationMessage::writeSimpleEdgeMessage</a></div><div class="ttdeci">bool writeSimpleEdgeMessage(MUTATION_MESSAGE_CODE code, ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div><div class="ttdoc">Procedure for writing REMOVE edge messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:570</div></div>
<div class="ttc" id="classTIGLContainersEdgeBase_html_a66709a50757848d82d194ddcdf5444be"><div class="ttname"><a href="classTIGLContainersEdgeBase.html#a66709a50757848d82d194ddcdf5444be">TIGLContainersEdgeBase::getNbr</a></div><div class="ttdeci">idType getNbr()</div><div class="ttdoc">Returns the id of the neighbor node. </div><div class="ttdef"><b>Definition:</b> tiglContainersEdgeBase.hpp:111</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a9f939c9fab8f95de9e5a7ce5e4e21764"><div class="ttname"><a href="classTIGLMutationMessage.html#a9f939c9fab8f95de9e5a7ce5e4e21764">TIGLMutationMessage::unpack</a></div><div class="ttdeci">uint_fast32_t unpack(uint8_t *buf)</div><div class="ttdoc">Unpacks a mutation message to the object fields. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:450</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a9985aad84627e17146f6413e8d117766"><div class="ttname"><a href="classTIGLMutationMessage.html#a9985aad84627e17146f6413e8d117766">TIGLMutationMessage::readAddVertexMessage</a></div><div class="ttdeci">bool readAddVertexMessage(CVertex *pVertex)</div><div class="ttdoc">Reads the ADD_VERTEX. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:264</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a4b5d767c6ed05892eed00407a290e599"><div class="ttname"><a href="classTIGLMutationMessage.html#a4b5d767c6ed05892eed00407a290e599">TIGLMutationMessage::readRemoveEdgeMessage</a></div><div class="ttdeci">bool readRemoveEdgeMessage(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div><div class="ttdoc">Reads the ADD/REMOVE_EDGE mutation message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:144</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a5c2f4752f5f1df26b608ddc6400777aa"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a5c2f4752f5f1df26b608ddc6400777aa">TIGLContainersVertexBase::getId</a></div><div class="ttdeci">IdType getId()</div><div class="ttdoc">Returns the vertex id. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:334</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_aa9d443dae0e56c7f05a1932937aa0295"><div class="ttname"><a href="classTIGLMutationMessage.html#aa9d443dae0e56c7f05a1932937aa0295">TIGLMutationMessage::prepareRemoveEdgeMessage</a></div><div class="ttdeci">uint_fast32_t prepareRemoveEdgeMessage(EDGE_TYPE *edge, ID_TYPE *targetVertex)</div><div class="ttdoc">Prepares the REMOVE_OUT/IN_EDGE mutation message. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:103</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_afaadae81d282d01fa6890bb5ec7c51ad"><div class="ttname"><a href="classTIGLMutationMessage.html#afaadae81d282d01fa6890bb5ec7c51ad">TIGLMutationMessage::readVertexMessage</a></div><div class="ttdeci">bool readVertexMessage(CVertex *vertex)</div><div class="ttdoc">Procedure for reading add/migrate vertex messages. </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:472</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html_a782c440fc6c8ae87291f142239260091"><div class="ttname"><a href="classTIGLContainersVertexBase.html#a782c440fc6c8ae87291f142239260091">TIGLContainersVertexBase::getAlgData</a></div><div class="ttdeci">AlgDataType &amp; getAlgData()</div><div class="ttdoc">Returns the algorithm data. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:323</div></div>
<div class="ttc" id="classTIGLContainersVertexBase_html"><div class="ttname"><a href="classTIGLContainersVertexBase.html">TIGLContainersVertexBase</a></div><div class="ttdoc">Core vertex class. </div><div class="ttdef"><b>Definition:</b> tiglContainersVertexBase.hpp:89</div></div>
<div class="ttc" id="classTIGLMutationMessage_html_a3d17a5a5e1dfe646b1dc7e8761a351b7"><div class="ttname"><a href="classTIGLMutationMessage.html#a3d17a5a5e1dfe646b1dc7e8761a351b7">TIGLMutationMessage::getSizeInBytes</a></div><div class="ttdeci">uint_fast32_t getSizeInBytes()</div><div class="ttdoc">reading the overall message body </div><div class="ttdef"><b>Definition:</b> tiglMutationMessageImplementation.hpp:381</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:52 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
